/*
 * Created on Mar 6, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package search;

import java.util.ArrayList;

import checkers.BitBoard;
import checkers.State;
/**
 * @author daltonj
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MiniMax {
	private final static int DEBUG = 1;
		
	private static final int INFINITY = Integer.MAX_VALUE;
	private static final long MAX = 0x7ffffffffL;
	private static int OrigDepth;
	
	private ArrayList successors;
	
	public State miniMaxSearch(State s, int depth){
		OrigDepth =depth;
		BitBoard tmpBoard = new BitBoard(s,AlphaBetaTest.hashy);
		int v = MaxValue(s, depth);
		for(int i =0; i< successors.size(); i++){
			State t1 = (State)successors.get(i);
			if(t1.v == v)
				return t1;
		}
		return null;
	}
	
	public int MaxValue(State s, int depth){
		--depth;
		if(OrigDepth-depth==1)
			successors.add(s);
		if (TerminalTest(s, depth))
			return s.hueristicVal;
		int v=-INFINITY;
		
		BitBoard tmpBoard = new BitBoard(s,AlphaBetaTest.hashy);
		for(int i=0; i<tmpBoard.nStates.size(); i++){
			v = Math.max(v,MinValue((State)tmpBoard.nStates.get(i),depth));
			s.v = v;
		}	
		return v;
	}
	
	public int MinValue(State s, int depth){
		
		if(TerminalTest(s, depth))
			return s.hueristicVal;
		--depth;
		int v = INFINITY;
		BitBoard tmpBoard = new BitBoard(s,AlphaBetaTest.hashy);
		for(int i=0; i<tmpBoard.nStates.size(); i++){
			v = Math.min(v,MaxValue((State)tmpBoard.nStates.get(i),depth));
			s.v = v;
		}
		return v;
	}
	
	public static boolean TerminalTest(State s, int depth){
		if ((s.B & MAX) ==0 || (s.W & MAX) ==0|| depth <= 0)
			return true;
		else return false;
	}
	
	public static void outputState(ArrayList l){
		for(int i=0; i<l.size();i++){
			State nState = (State)l.get(i);
			System.out.print(nState.toString());
			System.out.print("V Value: " + nState.v);
		}
	}
}
